/*
Class:      MCC_NListtree
Copyright:  (c)1999-2000 by Carsten Scholling
Author:     Carsten Scholling
Contact:    cs@aphaso.de
Contents:   Registered class of the Magic User Interface.
*/

/*** Include stuff ***/
MODULE  'libraries/mui'

/*** MUI Defines ***/

#define MUIC_NListtree   'NListtree.mcc'
#define NListtreeObject  MUI_NewObject(MUIC_NListtree

/*** Attributes ***/

#define MUIA_NListtree_Active                                $fec81201          // *** [.SGN]
#define MUIA_NListtree_ActiveList                            $fec81202          // *** [..GN]
#define MUIA_NListtree_CloseHook                             $fec81203          // *** [IS..]
#define MUIA_NListtree_ConstructHook                         $fec81204          // *** [IS..]
#define MUIA_NListtree_DestructHook                          $fec81205          // *** [IS..]
#define MUIA_NListtree_DisplayHook                           $fec81206          // *** [IS..]
#define MUIA_NListtree_DoubleClick                           $fec81207          // *** [ISGN]
#define MUIA_NListtree_DragDropSort                          $fec81208          // *** [IS..]
#define MUIA_NListtree_DupNodeName                           $fec81209          // *** [IS..]
#define MUIA_NListtree_EmptyNodes                            $fec8120a          // *** [IS..]
#define MUIA_NListtree_Format                                $fec8120b          // *** [IS..]
#define MUIA_NListtree_OpenHook                              $fec8120c          // *** [IS..]
#define MUIA_NListtree_Quiet                                 $fec8120d          // *** [.S..]
#define MUIA_NListtree_CompareHook                           $fec8120e          // *** [IS..]
#define MUIA_NListtree_Title                                 $fec8120f          // *** [IS..]
#define MUIA_NListtree_TreeColumn                            $fec81210          // *** [ISG.]
#define MUIA_NListtree_AutoVisible                           $fec81211          // *** [ISG.]
#define MUIA_NListtree_FindNameHook                          $fec81212          // *** [IS..]
#define MUIA_NListtree_MultiSelect                           $fec81213          // *** [I...]
#define MUIA_NListtree_MultiTestHook                         $fec81214          // *** [IS..]
#define MUIA_NListtree_CopyToClipHook                        $fec81217          // *** [IS..]
#define MUIA_NListtree_DropType                              $fec81218          // *** [..G.]
#define MUIA_NListtree_DropTarget                            $fec81219          // *** [..G.]
#define MUIA_NListtree_DropTargetPos                         $fec8121a          // *** [..G.]
#define MUIA_NListtree_FindUserDataHook                      $fec8121b          // *** [IS..]
#define MUIA_NListtree_ShowTree                              $fec8121c          // *** [ISG.]
#define MUIA_NListtree_SelectChange                          $fec8121d          // *** [ISGN]

/*** Special attribute values ***/

#define MUIV_NListtree_Active_Off                            0
#define MUIV_NListtree_Active_Parent                         -2
#define MUIV_NListtree_Active_First                          -3
#define MUIV_NListtree_Active_FirstVisible                   -4
#define MUIV_NListtree_Active_LastVisible                    -5
#define MUIV_NListtree_ActiveList_Off                        0
#define MUIV_NListtree_AutoVisible_Off                       0
#define MUIV_NListtree_AutoVisible_Normal                    1
#define MUIV_NListtree_AutoVisible_FirstOpen                 2
#define MUIV_NListtree_AutoVisible_Expand                    3
#define MUIV_NListtree_CompareHook_Head                      0
#define MUIV_NListtree_CompareHook_Tail                      -1
#define MUIV_NListtree_CompareHook_LeavesTop                 -2
#define MUIV_NListtree_CompareHook_LeavesMixed               -3
#define MUIV_NListtree_CompareHook_LeavesBottom              -4
#define MUIV_NListtree_ConstructHook_String                  -1
#define MUIV_NListtree_ConstructHook_Flag_AutoCreate         (1<<15)
#define MUIV_NListtree_CopyToClipHook_Default                0
#define MUIV_NListtree_DestructHook_String                   -1
#define MUIV_NListtree_DisplayHook_Default                   -1
#define MUIV_NListtree_DoubleClick_Off                       -1
#define MUIV_NListtree_DoubleClick_All                       -2
#define MUIV_NListtree_DoubleClick_Tree                      -3
#define MUIV_NListtree_DoubleClick_NoTrigger                 -4
#define MUIV_NListtree_DropType_None                         0
#define MUIV_NListtree_DropType_Above                        1
#define MUIV_NListtree_DropType_Below                        2
#define MUIV_NListtree_DropType_Onto                         3
#define MUIV_NListtree_DropType_Sorted                       4
#define MUIV_NListtree_FindNameHook_CaseSensitive            0
#define MUIV_NListtree_FindNameHook_CaseInsensitive          -1
#define MUIV_NListtree_FindNameHook_Part                     -2
#define MUIV_NListtree_FindNameHook_PartCaseInsensitive      -3
#define MUIV_NListtree_FindNameHook_PointerCompare           -4
#define MUIV_NListtree_FindUserDataHook_CaseSensitive        0
#define MUIV_NListtree_FindUserDataHook_CaseInsensitive      -1
#define MUIV_NListtree_FindUserDataHook_Part                 -2
#define MUIV_NListtree_FindUserDataHook_PartCaseInsensitive  -3
#define MUIV_NListtree_FindUserDataHook_PointerCompare       -4
#define MUIV_NListtree_MultiSelect_None                      0
#define MUIV_NListtree_MultiSelect_Default                   1
#define MUIV_NListtree_MultiSelect_Shifted                   2
#define MUIV_NListtree_MultiSelect_Always                    3
#define MUIV_NListtree_ShowTree_Toggle                       -1

/*** Structures & Flags ***/

OBJECT MUI_NListtree_TreeNode
        Node:MinNode,         // ***  To make it a node.
        Name:PTR TO UBYTE,    // ***  Simple name field.
        Flags:UWORD,          // ***  Used for the flags below.
        User:PTR              // ***  Free for user data.

#define TNF_OPEN                     (1<<0)
#define TNF_LIST                     (1<<1)
#define TNF_FROZEN                   (1<<2)
#define TNF_NOSIGN                   (1<<3)
#define TNF_SELECTED                 (1<<4)

OBJECT MUI_NListtree_TestPos_Result
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Type:UWORD,
        ListEntry:LONG,
        ListFlags:UWORD,
        Column:WORD

/*** Methods ***/

#define MUIM_NListtree_Open                                  $fec81101
#define MUIM_NListtree_Close                                 $fec81102
#define MUIM_NListtree_Insert                                $fec81103
#define MUIM_NListtree_Remove                                $fec81104
#define MUIM_NListtree_Exchange                              $fec81105
#define MUIM_NListtree_Move                                  $fec81106
#define MUIM_NListtree_Rename                                $fec81107
#define MUIM_NListtree_FindName                              $fec81108
#define MUIM_NListtree_GetEntry                              $fec81109
#define MUIM_NListtree_GetNr                                 $fec8110a
#define MUIM_NListtree_Sort                                  $fec8110b
#define MUIM_NListtree_TestPos                               $fec8110c
#define MUIM_NListtree_Redraw                                $fec8110d
#define MUIM_NListtree_NextSelected                          $fec81110
#define MUIM_NListtree_MultiTest                             $fec81111
#define MUIM_NListtree_Select                                $fec81112
#define MUIM_NListtree_Copy                                  $fec81113
#define MUIM_NListtree_InsertStruct                          $fec81114          // *** Insert a struct (like a path) into the list.
#define MUIM_NListtree_Active                                $fec81115          // *** Method which gives the active node/number.
#define MUIM_NListtree_DoubleClick                           $fec81116          // *** Occurs on every double click.
#define MUIM_NListtree_PrevSelected                          $fec81118          // *** Like reverse NextSelected.
#define MUIM_NListtree_CopyToClip                            $fec81119          // *** Copy an entry or part to the clipboard.
#define MUIM_NListtree_FindUserData                          $fec8111a          // *** Find a node upon user data.
#define MUIM_NListtree_Clear                                 $fec8111b          // *** Clear complete tree.
#define MUIM_NListtree_DropType                              $fec8111e          // ***
#define MUIM_NListtree_DropDraw                              $fec8111f          // ***

/*** Method structs ***/

OBJECT MUIP_NListtree_Open
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Close
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Insert
        MethodID:ULONG,
        Name:PTR TO UBYTE,
        User:PTR,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        PrevNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Remove
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Clear
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_FindName
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        Name:PTR TO UBYTE,
        Flags:ULONG

OBJECT MUIP_NListtree_FindUserData
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        User:PTR,
        Flags:ULONG

OBJECT MUIP_NListtree_GetEntry
        MethodID:ULONG,
        Node:PTR TO MUI_NListtree_TreeNode,
        Position:LONG,
        Flags:ULONG

OBJECT MUIP_NListtree_GetNr
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Move
        MethodID:ULONG,
        OldListNode:PTR TO MUI_NListtree_TreeNode,
        OldTreeNode:PTR TO MUI_NListtree_TreeNode,
        NewListNode:PTR TO MUI_NListtree_TreeNode,
        NewTreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Exchange
        MethodID:ULONG,
        ListNode1:PTR TO MUI_NListtree_TreeNode,
        TreeNode1:PTR TO MUI_NListtree_TreeNode,
        ListNode2:PTR TO MUI_NListtree_TreeNode,
        TreeNode2:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Rename
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        NewName:PTR TO UBYTE,
        Flags:ULONG

OBJECT MUIP_NListtree_Sort
        MethodID:ULONG,
        ListNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_TestPos
        MethodID:ULONG,
        X:LONG,
        Y:LONG,
        Result:PTR

OBJECT MUIP_NListtree_Redraw
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_Select
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        SelType:LONG,
        SelFlags:LONG,
        State:PTR TO LONG

OBJECT MUIP_NListtree_NextSelected
        MethodID:ULONG,
        TreeNode:PTR TO PTR TO MUI_NListtree_TreeNode

OBJECT MUIP_NListtree_MultiTest
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        SelType:LONG,
        SelFlags:LONG,
        CurrType:LONG

OBJECT MUIP_NListtree_Copy
        MethodID:ULONG,
        SourceListNode:PTR TO MUI_NListtree_TreeNode,
        SourceTreeNode:PTR TO MUI_NListtree_TreeNode,
        DestListNode:PTR TO MUI_NListtree_TreeNode,
        DestTreeNode:PTR TO MUI_NListtree_TreeNode,
        Flags:ULONG

OBJECT MUIP_NListtree_InsertStruct
        MethodID:ULONG,
        Name:PTR TO UBYTE,
        User:PTR,
        Delimiter:PTR TO UBYTE,
        Flags:ULONG

OBJECT MUIP_NListtree_Active
        MethodID:ULONG,
        Pos:LONG,
        ActiveNode:PTR TO MUI_NListtree_TreeNode

OBJECT MUIP_NListtree_DoubleClick
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Entry:LONG,
        Column:LONG

OBJECT MUIP_NListtree_PrevSelected
        MethodID:ULONG,
        TreeNode:PTR TO PTR TO MUI_NListtree_TreeNode

OBJECT MUIP_NListtree_CopyToClip
        MethodID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Pos:LONG,
        Unit:LONG

OBJECT MUIP_NListtree_DropType
        MethodID:ULONG,
        Pos:PTR TO LONG,
        Type:PTR TO LONG,
        MinX:LONG,
        MaxX:LONG,
        MinY:LONG,
        MaxY:LONG,
        MouseX:LONG,
        MouseY:LONG

OBJECT MUIP_NListtree_DropDraw
        MethodID:ULONG,
        Pos:LONG,
        Type:LONG,
        MinX:LONG,
        MaxX:LONG,
        MinY:LONG,
        MaxY:LONG

/*** Special method values ***/

#define MUIV_NListtree_Close_ListNode_Root                   0
#define MUIV_NListtree_Close_ListNode_Parent                 -1
#define MUIV_NListtree_Close_ListNode_Active                 -2
#define MUIV_NListtree_Close_TreeNode_Head                   0
#define MUIV_NListtree_Close_TreeNode_Tail                   -1
#define MUIV_NListtree_Close_TreeNode_Active                 -2
#define MUIV_NListtree_Close_TreeNode_All                    -3
#define MUIV_NListtree_Exchange_ListNode1_Root               0
#define MUIV_NListtree_Exchange_ListNode1_Active             -2
#define MUIV_NListtree_Exchange_TreeNode1_Head               0
#define MUIV_NListtree_Exchange_TreeNode1_Tail               -1
#define MUIV_NListtree_Exchange_TreeNode1_Active             -2
#define MUIV_NListtree_Exchange_ListNode2_Root               0
#define MUIV_NListtree_Exchange_ListNode2_Active             -2
#define MUIV_NListtree_Exchange_TreeNode2_Head               0
#define MUIV_NListtree_Exchange_TreeNode2_Tail               -1
#define MUIV_NListtree_Exchange_TreeNode2_Active             -2
#define MUIV_NListtree_Exchange_TreeNode2_Up                 -5
#define MUIV_NListtree_Exchange_TreeNode2_Down               -6
#define MUIV_NListtree_FindName_ListNode_Root                0
#define MUIV_NListtree_FindName_ListNode_Active              -2
#define MUIV_NListtree_FindName_Flag_SameLevel               (1<<15)
#define MUIV_NListtree_FindName_Flag_Visible                 (1<<14)
#define MUIV_NListtree_FindName_Flag_Activate                (1<<13)
#define MUIV_NListtree_FindName_Flag_Selected                (1<<11)
#define MUIV_NListtree_FindName_Flag_StartNode               (1<<10)
#define MUIV_NListtree_FindName_Flag_Reverse                 (1<<9)
#define MUIV_NListtree_FindUserData_ListNode_Root            0
#define MUIV_NListtree_FindUserData_ListNode_Active          -2
#define MUIV_NListtree_FindUserData_Flag_SameLevel           (1<<15)
#define MUIV_NListtree_FindUserData_Flag_Visible             (1<<14)
#define MUIV_NListtree_FindUserData_Flag_Activate            (1<<13)
#define MUIV_NListtree_FindUserData_Flag_Selected            (1<<11)
#define MUIV_NListtree_FindUserData_Flag_StartNode           (1<<10)
#define MUIV_NListtree_FindUserData_Flag_Reverse             (1<<9)
#define MUIV_NListtree_GetEntry_ListNode_Root                0
#define MUIV_NListtree_GetEntry_ListNode_Active              -2
#define MUIV_NListtree_GetEntry_TreeNode_Active              -3
#define MUIV_NListtree_GetEntry_Position_Head                0
#define MUIV_NListtree_GetEntry_Position_Tail                -1
#define MUIV_NListtree_GetEntry_Position_Active              -2
#define MUIV_NListtree_GetEntry_Position_Next                -3
#define MUIV_NListtree_GetEntry_Position_Previous            -4
#define MUIV_NListtree_GetEntry_Position_Parent              -5
#define MUIV_NListtree_GetEntry_Flag_SameLevel               (1<<15)
#define MUIV_NListtree_GetEntry_Flag_Visible                 (1<<14)
#define MUIV_NListtree_GetNr_TreeNode_Active                 -2
#define MUIV_NListtree_GetNr_Flag_CountAll                   (1<<15)
#define MUIV_NListtree_GetNr_Flag_CountLevel                 (1<<14)
#define MUIV_NListtree_GetNr_Flag_CountList                  (1<<13)
#define MUIV_NListtree_GetNr_Flag_ListEmpty                  (1<<12)
#define MUIV_NListtree_GetNr_Flag_Visible                    (1<<11)
#define MUIV_NListtree_Insert_ListNode_Root                  0
#define MUIV_NListtree_Insert_ListNode_Active                -2
#define MUIV_NListtree_Insert_ListNode_LastInserted          -3
#define MUIV_NListtree_Insert_ListNode_ActiveFallback        -4
#define MUIV_NListtree_Insert_PrevNode_Head                  0
#define MUIV_NListtree_Insert_PrevNode_Tail                  -1
#define MUIV_NListtree_Insert_PrevNode_Active                -2
#define MUIV_NListtree_Insert_PrevNode_Sorted                -4
#define MUIV_NListtree_Insert_Flag_Active                    (1<<13)
#define MUIV_NListtree_Insert_Flag_NextNode                  (1<<12)
#define MUIV_NListtree_Move_OldListNode_Root                 0
#define MUIV_NListtree_Move_OldListNode_Active               -2
#define MUIV_NListtree_Move_OldTreeNode_Head                 0
#define MUIV_NListtree_Move_OldTreeNode_Tail                 -1
#define MUIV_NListtree_Move_OldTreeNode_Active               -2
#define MUIV_NListtree_Move_NewListNode_Root                 0
#define MUIV_NListtree_Move_NewListNode_Active               -2
#define MUIV_NListtree_Move_NewTreeNode_Head                 0
#define MUIV_NListtree_Move_NewTreeNode_Tail                 -1
#define MUIV_NListtree_Move_NewTreeNode_Active               -2
#define MUIV_NListtree_Move_NewTreeNode_Sorted               -4
#define MUIV_NListtree_Move_Flag_KeepStructure               (1<<13)
#define MUIV_NListtree_Open_ListNode_Root                    0
#define MUIV_NListtree_Open_ListNode_Parent                  -1
#define MUIV_NListtree_Open_ListNode_Active                  -2
#define MUIV_NListtree_Open_TreeNode_Head                    0
#define MUIV_NListtree_Open_TreeNode_Tail                    -1
#define MUIV_NListtree_Open_TreeNode_Active                  -2
#define MUIV_NListtree_Open_TreeNode_All                     -3
#define MUIV_NListtree_Remove_ListNode_Root                  0
#define MUIV_NListtree_Remove_ListNode_Active                -2
#define MUIV_NListtree_Remove_TreeNode_Head                  0
#define MUIV_NListtree_Remove_TreeNode_Tail                  -1
#define MUIV_NListtree_Remove_TreeNode_Active                -2
#define MUIV_NListtree_Remove_TreeNode_All                   -3
#define MUIV_NListtree_Remove_TreeNode_Selected              -4
#define MUIV_NListtree_Remove_Flag_NoActive                  (1<<13)
#define MUIV_NListtree_Rename_TreeNode_Active                -2
#define MUIV_NListtree_Rename_Flag_User                      (1<<8)
#define MUIV_NListtree_Rename_Flag_NoRefresh                 (1<<9)
#define MUIV_NListtree_Sort_ListNode_Root                    0
#define MUIV_NListtree_Sort_ListNode_Active                  -2
#define MUIV_NListtree_Sort_TreeNode_Active                  -3
#define MUIV_NListtree_Sort_Flag_RecursiveOpen               (1<<13)
#define MUIV_NListtree_Sort_Flag_RecursiveAll                (1<<12)
#define MUIV_NListtree_TestPos_Result_None                   0
#define MUIV_NListtree_TestPos_Result_Above                  1
#define MUIV_NListtree_TestPos_Result_Below                  2
#define MUIV_NListtree_TestPos_Result_Onto                   3
#define MUIV_NListtree_TestPos_Result_Sorted                 4
#define MUIV_NListtree_Redraw_Active                         -1
#define MUIV_NListtree_Redraw_All                            -2
#define MUIV_NListtree_Redraw_Flag_Nr                        (1<<15)
#define MUIV_NListtree_Select_Active                         -1
#define MUIV_NListtree_Select_All                            -2
#define MUIV_NListtree_Select_Visible                        -3
#define MUIV_NListtree_Select_Off                            0
#define MUIV_NListtree_Select_On                             1
#define MUIV_NListtree_Select_Toggle                         2
#define MUIV_NListtree_Select_Ask                            3
#define MUIV_NListtree_Select_Flag_Force                     (1<<15)
#define MUIV_NListtree_NextSelected_Start                    -1
#define MUIV_NListtree_NextSelected_End                      -1
#define MUIV_NListtree_Copy_SourceListNode_Root              0
#define MUIV_NListtree_Copy_SourceListNode_Active            -2
#define MUIV_NListtree_Copy_SourceTreeNode_Head              0
#define MUIV_NListtree_Copy_SourceTreeNode_Tail              -1
#define MUIV_NListtree_Copy_SourceTreeNode_Active            -2
#define MUIV_NListtree_Copy_DestListNode_Root                0
#define MUIV_NListtree_Copy_DestListNode_Active              -2
#define MUIV_NListtree_Copy_DestTreeNode_Head                0
#define MUIV_NListtree_Copy_DestTreeNode_Tail                -1
#define MUIV_NListtree_Copy_DestTreeNode_Active              -2
#define MUIV_NListtree_Copy_DestTreeNode_Sorted              -4
#define MUIV_NListtree_Copy_Flag_KeepStructure               (1<<13)
#define MUIV_NListtree_PrevSelected_Start                    -1
#define MUIV_NListtree_PrevSelected_End                      -1
#define MUIV_NListtree_CopyToClip_Active                     -1

/*** Hook message structs ***/

OBJECT MUIP_NListtree_CloseMessage
        HookID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode

OBJECT MUIP_NListtree_CompareMessage
        HookID:ULONG,
        TreeNode1:PTR TO MUI_NListtree_TreeNode,
        TreeNode2:PTR TO MUI_NListtree_TreeNode,
        SortType:LONG

OBJECT MUIP_NListtree_ConstructMessage
        HookID:ULONG,
        Name:PTR TO UBYTE,
        UserData:PTR,
        MemPool:PTR,
        Flags:ULONG

OBJECT MUIP_NListtree_DestructMessage
        HookID:ULONG,
        Name:PTR TO UBYTE,
        UserData:PTR,
        MemPool:PTR,
        Flags:ULONG

OBJECT MUIP_NListtree_DisplayMessage
        HookID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        EntryPos:LONG,
        Array:PTR TO UBYTE,
        Preparse:PTR TO UBYTE

OBJECT MUIP_NListtree_CopyToClipMessage
        HookID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        Pos:LONG,
        Unit:LONG

OBJECT MUIP_NListtree_FindNameMessage
        HookID:ULONG,
        Name:PTR TO UBYTE,
        NodeName:PTR TO UBYTE,
        UserData:PTR,
        Flags:ULONG

OBJECT MUIP_NListtree_FindUserDataMessage
        HookID:ULONG,
        User:PTR,
        UserData:PTR,
        NodeName:PTR TO UBYTE,
        Flags:ULONG

OBJECT MUIP_NListtree_OpenMessage
        HookID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode

OBJECT MUIP_NListtree_MultiTestMessage
        HookID:ULONG,
        TreeNode:PTR TO MUI_NListtree_TreeNode,
        SelType:LONG,
        SelFlags:LONG,
        CurrType:LONG

