/*********************************************************
**                                                      **
**      SpeedBar.mcc                                    **
**                                                      **
**              1999 Simone Tellini                    **
**                                                      **
*********************************************************/

MODULE  'libraries/mui'

#define MUIC_SpeedBar        'SpeedBar.mcc'
#define SpeedBarObject       MUI_NewObject( MUIC_SpeedBar
#define SBTAGBASE            $F76B00A0

/*************************
**      Methods         **
*************************/

#define MUIM_SpeedBar_AddButton          (SBTAGBASE + 1)
#define MUIM_SpeedBar_AddButtonObject    (SBTAGBASE + 2)
#define MUIM_SpeedBar_AddSpacer          (SBTAGBASE + 3)
#define MUIM_SpeedBar_Clear              (SBTAGBASE + 4)
#define MUIM_SpeedBar_Rebuild            (SBTAGBASE + 5)
#define MUIM_SpeedBar_AddNotify          (SBTAGBASE + 6)        /*  PRIVATE  */
#define MUIM_SpeedBar_GetObject          (SBTAGBASE + 7)
#define MUIM_SpeedBar_DoOnButton         (SBTAGBASE + 8)

/*************************
**      Attributes      **
*************************/

#define MUIA_SpeedBar_Borderless         (SBTAGBASE + 1)        /*  BOOL                IS.. */
#define MUIA_SpeedBar_Images             (SBTAGBASE + 2)        /*  struct MyBrush **   I.G. */
#define MUIA_SpeedBar_SpacerIndex        (SBTAGBASE + 3)        /*  UWORD               I.G. */
#define MUIA_SpeedBar_RaisingFrame       (SBTAGBASE + 4)        /*  BOOL                IS.. */
#define MUIA_SpeedBar_Buttons            (SBTAGBASE + 5)        /*  struct SBButtons *  I... */
#define MUIA_SpeedBar_ViewMode           (SBTAGBASE + 6)        /*  UWORD               ISG. */
#define MUIA_SpeedBar_SameWidth          (SBTAGBASE + 7)        /*  BOOL                I... */
#define MUIA_SpeedBar_Spread             (SBTAGBASE + 8)        /*  BOOL                I... */
#define MUIA_SpeedBar_StripUnderscore    (SBTAGBASE + 9)        /*  BOOL                I... */
#define MUIA_SpeedBar_SmallImages        (SBTAGBASE + 10)       /*  BOOL                IS.. */
#define MUIA_SpeedBar_Sunny              (SBTAGBASE + 11)       /*  BOOL                IS.. */
#define MUIA_SpeedBar_SameHeight         (SBTAGBASE + 12)       /*  BOOL                I... */

/*************************
**      Values          **
*************************/

#define MUIV_SpeedBar_Spacer             -1
#define MUIV_SpeedBar_End                -2    // ends a MUIS_SpeedBar_Button array
#define MUIV_SpeedBar_ButtonFlag_Immediate   (1 << 0)
#define MUIV_SpeedBar_ButtonFlag_Disabled    (1 << 1)
#define MUIV_SpeedBar_ButtonFlag_Selected    (1 << 2)
#define MUIV_SpeedBar_ButtonFlag_Toggle      (1 << 3)
#define MUIV_SpeedBar_ViewMode_TextGfx   0
#define MUIV_SpeedBar_ViewMode_Gfx       1
#define MUIV_SpeedBar_ViewMode_Text      2

/*************************
**      Structures      **
*************************/

OBJECT MUIS_SpeedBar_Button
        Img:ULONG,               /* image index                                          */
        Text:PTR TO UBYTE,       /* button label                                         */
        Help:PTR TO UBYTE,       /* button help                                          */
        Flags:UWORD,
        Class:PTR TO IClass,     /* easy way of getting a toolbar of subclassed buttons  */
        Object:PTR TO _Object     /* filled after init                                    */

OBJECT MUIP_SpeedBar_AddButton
        MethodID:ULONG,
        Button:PTR TO MUIS_SpeedBar_Button

OBJECT MUIP_SpeedBar_AddButtonObject
        MethodID:ULONG,
        Button:PTR TO _Object

OBJECT MUIP_SpeedBar_AddNotify
        MethodID:ULONG,
        Dest:PTR TO _Object,
        Msg:PTR TO MUIP_Notify

OBJECT MUIP_SpeedBar_GetObject
        MethodID:ULONG,
        Object:ULONG

OBJECT MUIP_SpeedBar_DoOnButton
        MethodID:ULONG,
        Button:ULONG,
        Method:ULONG       /* ...args... */

