/*
 * $Id: netdb.h,v 1.11 1994/04/03 23:41:20 jraja Exp $
 *
 * Network Database Structures and Defintions
 *
 * Copyright  1993 AmiTCP/IP Group, <amitcp-group@hut.fi>
 *                  Helsinki University of Technology, Finland.
 *                  All rights reserved.
 */

/*-
 * Copyright (c) 1980, 1983, 1988 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, and (2) distributions including binaries display
 * the following acknowledgement:  ``This product includes software
 * developed by the University of California, Berkeley and its contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the University nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#define _PATH_DB            'AmiTCP:db'
#define _PATH_AMITCP_CONFIG 'AmiTCP:db/AmiTCP.config'
#define _PATH_NETDB         'AmiTCP:db/netdb'
#define _PATH_HEQUIV        'AmiTCP:db/hosts.equiv'
#define _PATH_INETDCONF     'AmiTCP:db/inetd.conf'

/*
 * Structures returned by network data base library.  All addresses are
 * supplied in host order, and returned in network order (suitable for
 * use in system calls).
 */
OBJECT hostent
    h_name:PTR TO BYTE,              /* official name of host */
    h_aliases:PTR TO PTR TO BYTE,    /* alias list */
    h_addrtype:LONG,                 /* host address type */
    h_length:LONG,                   /* length of address */
    h_addr_list:PTR TO PTR TO BYTE   /* list of addresses from name server */


/*
 * Assumption here is that a network number
 * fits in 32 bits -- probably a poor one.
 */
OBJECT netent
    n_name:PTR TO BYTE,           /* official name of net */
    n_aliases:PTR TO PTR TO BYTE, /* alias list */
    n_addrtype:LONG,              /* net address type */
    n_net:ULONG                   /* network # */


OBJECT servent
    s_name:PTR TO BYTE,            /* official service name */
    s_aliases:PTR TO PTR TO BYTE,  /* alias list */
    s_port:LONG,                   /* port # */
    s_proto:PTR TO BYTE            /* protocol to use */


OBJECT protoent
    p_name:PTR TO BYTE,             /* official protocol name */
    p_aliases:PTR TO PTR TO BYTE,    /* alias list */
    p_proto:LONG                    /* protocol # */


/*
 * Error return codes from gethostbyname() and gethostbyaddr()
 * (left in extern int h_errno).
 */

#define HOST_NOT_FOUND  1         /* Authoritative Answer Host not found */
#define TRY_AGAIN       2         /* Non-Authoritive Host not found, or SERVERFAIL */
#define NO_RECOVERY     3         /* Non recoverable errors, FORMERR, REFUSED, NOTIMP */
#define NO_DATA         4         /* Valid name, no data record of requested type */
#define NO_ADDRESS      NO_DATA   /* no address, look for MX record */


