/*************************************************************************
 ** 68040.library                                                 **
 **                                                                     **
 ** CPU driver library for the 68040          **
 **                                                                     **
 **  1999 THOR-Software, Thomas Richter                                **
 ** No commercial use, reassembly, modification without prior, written  **
 ** permission of the authors.                                          **
 ** Including this library in any commercial software REQUIRES a        **
 ** written permission and the payment of a small fee.                  **
 **                                                                     **
 **---------------------------------------------------------------------**
 ** Definition of the library, and structures                           **
 **                 **
 ** $VER: 40.2 (31.10.99)  THOR                            **
 *************************************************************************/
#ifndef LIBRARIES_68040_M
#define LIBRARIES_68040_M 
MODULE 'exec/libraries','mmu/mmubase'
/* There's really nothing in this library base you need to care about */
OBJECT MC68040Base
  Library:Library     /* more below this point */

#define MC68040_NAME '68040.library'
/* Bit definitions for the FPUControl call, exception disable */
FLAG FPUCtrl_BSUN=0,   /* disable branch or set on unordered */
 FPUCtrl_INEX=1,   /* disable inexact result exception */
 FPUCtrl_DIVZ=2,   /* disable divide by zero exception */
 FPUCtrl_UNFL=3,   /* disable underflow exception */
 FPUCtrl_OVFL=4,   /* disable overflow exception */
 FPUCtrl_SNAN=5,   /* disable signalling NAN exception */
 FPUCtrl_OPERR=6   /* disable operand error exception */
#endif
