/*************************************************************************
 ** 680x0.library                                                 **
 **                                                                     **
 ** CPU driver library base library         **
 **                                                                     **
 **  1999 THOR-Software, Thomas Richter                                **
 ** No commercial use, reassembly, modification without prior, written  **
 ** permission of the authors.                                          **
 ** Including this library in any commercial software REQUIRES a        **
 ** written permission and the payment of a small fee.                  **
 **                                                                     **
 **---------------------------------------------------------------------**
 ** Definition of the library, and structures                           **
 **                 **
 ** $VER: 40.2 (28.8.1999)  THOR                           **
 *************************************************************************/
#ifndef LIBRARIES_680X0_M
#define LIBRARIES_680X0_M 
MODULE 'exec/libraries','mmu/mmubase'
/* There's really nothing in this library base you need to care about */

OBJECT MC680x0Base
  Library:Library     /* more below this point */

#define MC680x0_NAME '680x0.library'
/* Bit definitions for the SetFPUExceptions call, exception disable */
FLAG FPUCtrl_BSUN=0,   /* disable branch or set on unordered */
 FPUCtrl_INEX=1,   /* disable inexact result exception */
 FPUCtrl_DIVZ=2,   /* disable divide by zero exception */
 FPUCtrl_UNFL=3,   /* disable underflow exception */
 FPUCtrl_OVFL=4,   /* disable overflow exception */
 FPUCtrl_SNAN=5,   /* disable signalling NAN exception */
 FPUCtrl_OPERR=6   /* disable operand error exception */
/* CPU and FPU definitions. */
#define CPUTYPE_68000   "0" /* a plain 68000*/
#define CPUTYPE_68010   "1" /* a 68010  */
#define CPUTYPE_68020   "2" /* a 68020  */
#define CPUTYPE_68030   "3" /* a 68030  */
#define CPUTYPE_68040   "4" /* a 68040  */
#define CPUTYPE_68060   "6" /* a 68060  */
#define FPUTYPE_NONE  0 /* no FPU available */
#define FPUTYPE_68881   "1" /* the 68881 external FPU   */
#define FPUTYPE_68882   "2" /* the advanced edition of this chip */
#define FPUTYPE_68040   "4" /* the 68040 buildin FPU  */
#define FPUTYPE_68060   "6" /* the 68060 buildin FPU  */
#endif
