MODULE 'exec/execbase','mmu/mmubase','mmu/context'

OBJECT ExceptionData
  Task:PTR TO Task,
  Context:PTR TO MMUContext,
  Descriptor:PTR TO ULONG,
  NextDescriptor:PTR TO ULONG,
  FaultAddress:PTR,
  NextFaultAddress:PTR,
  UserData:ULONG,
  NextUserData:ULONG,
  Data:ULONG,
  ReturnPC:APTR,
  Flags:ULONG,
  internal:UBYTE,
  Properties:ULONG,
  NextProperties:ULONG,
  FunctionCode:UBYTE,
  Level:BYTE,
  NextLevel:BYTE,
  DataRegs[8]:ULONG,
  AddrRegs[7]:ULONG,
  SSP:PTR TO UWORD,
  USP:PTR TO UWORD,
  SysBase:PTR TO ExecBase,
  MMUBase:PTR TO MMUBase

FLAG EXD_WRITE=0,
 EXD_INSTRUCTION,
 EXD_WRITEPROTECTED,
 EXD_WRITEDATAUNKNOWN,
 EXD_SUPERVISOR=6,
 EXD_MISALIGNED=8,
 EXD_READBACK=16,
 EXD_WRITECOMPLETE=16,
 EXD_CALL

CONST MMUEH_SEGFAULT=0,
 MMUEH_SWAPPED=1,
 MMUEH_SWITCH=$10,
 MMUEH_LAUNCH=$11,
 MMUEH_PAGEACCESS=$20

OBJECT ExceptionHook
  Interrupt:Interrupt

OBJECT ExceptionMessage
  Message:Message,
  Exception:ExceptionData

OBJECT PageAccessData
  Level:ULONG,
  Address:VOID,
  Destination:PTR TO ULONG,
  Context:PTR TO MMUContext,
  MMUBase:PTR TO MMUBase,
  Properties:ULONG,
  UserData:ULONG
